<template>
  <div>
    <overlay
      :overlay="!selectedPeriod"
    />
    <v-container fluid>
      <v-row>
        <v-col>
          <stats />
        </v-col>
      </v-row>

      <v-row>
        <v-col>
          <material-chart-card
            :color="chart.color"
            :data="chart.data"
            :options="chart.options"
            :responsive-options="chart.responsiveOptions"
            :title="chart.title"
            :type="chart.type"
          >
            <template #subtitle>
              <div class="font-weight-light text--secondary">
                <div v-html="chart.subtitle" />
              </div>
            </template>

            <template #actions>
              <v-icon
                class="mr-1"
                small
              >
                mdi-clock-outline
              </v-icon>

              <span
                class="text-caption grey--text font-weight-light"
                v-text="chart.time"
              />
            </template>
          </material-chart-card>
        </v-col>
      </v-row>

      <v-row>
        <v-col>
          <simple-table
            :items="chartData"
            :is-loading="isChartDataLoading"
          />
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script>
  import { formatMonth } from '@/lib/date'
  import getChart from './chart'
  import { max, min, flatten } from 'lodash'
  // components
  import SimpleTable from './components/SimpleTable'
  import Stats from './components/Stats'

  export default {
    name: 'DashboardView',
    components: {
      Stats,
      SimpleTable,
    },
    data () {
      return {
        chartData: [],
        isChartDataLoading: false,
        chart: getChart((key, params) => this.$t(key, params)),
        // callbacks
        loadStatsCallback: null,
      }
    },
    computed: {
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
    },
    watch: {
      selectedPeriod: {
        handler (period) {
          if (period && period.id) {
            this.loadChartData()
          }
        },
        deep: true,
      },
    },
    created () {
      this.loadChartData()
    },
    methods: {
      setChartData (labels, series, high, low) {
        this.chart = getChart(
          (key, params) => this.$t(key, params),
          labels,
          series,
          high,
          low,
        )
      },
      loadChartData () {
        this.isChartDataLoading = true
        this.$store.dispatch('dashboard/getChartData', this.selectedPeriod.id)
          .then(({ data }) => {
            this.chartData = data
            const labels = data.map(chartData => formatMonth(chartData.referenceMonth))
            const incomesSum = data.map(chartData => chartData.incomesSum)
            const expensesSum = data.map(chartData => chartData.expensesSum)
            const difference = data.map(chartData => chartData.difference)
            const accrued = data.map(chartData => chartData.accrued)
            const series = [
              incomesSum,
              expensesSum,
              difference,
              accrued,
            ]
            const flattened = flatten(series)
            const high = max(flattened)
            const low = min(flattened)
            this.setChartData(labels, series, high, low)
          })
          .finally(() => {
            this.isChartDataLoading = false
          })
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          chart: {
            title: 'Estatísticas por mês',
            subtitle: 'As barras do gráfico representam, respectivamente, Receita, Despesa, Diferença e Acumulado por mês.',
            updated: 'Atualizado {time}',
          },
        },
        'en-US': {
          chart: {
            title: 'Statistics by month',
            subtitle: 'The bars on the graph represent, respectively, Income, Expense, Difference and Accrued by month.',
            updated: 'Updated {time}',
          },
        },
      },
    },
  }
</script>
